#! /usr/bin/env python
#
# Copyright 2007  Jochen Voss <voss@seehuhn.de>
#
# This file is part of the CSimGen package.
#
# CSimGen is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301 USA

"""C code generator for use in numerical simulations.

CSimGen helps to write Python programs which construct C programs for
use in numerical simulations.  Things CSimGen can do for you:

* keep track of the in-memory representation of matrices
* construct LAPACK calls
* dynamically allocate memory for matrices and vectors
* ...

To learn how to use CSimGen either read the documentation at the
CSimGen homepage http://seehuhn.de/comp/csimgen/ or read the online
documentation of the csimgen.code module.

WARNING: this is an experimental version of CSimGen.  The API is not
yet finalised and may change without further notice.
"""

__version__ = '0.1'
