#! /usr/bin/env python
#
# Copyright 2007  Jochen Voss <voss@seehuhn.de>
#
# This file is part of the CSimGen package.
#
# CSimGen is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301 USA

"""Helpers for python exception/error handling.

WARNING: this is an experimental version of CSimGen.  The API is not
yet finalised and may change without further notice.
"""

__author__ = 'Jochen Voss'
__version__ = '0.1'

from inspect import currentframe

def checkOptArgs(kwargs, **defaults):
    res = {}
    for k in defaults:
        res[k] = kwargs.pop(k, defaults[k])
    if kwargs:
        frame = currentframe()
        try:
            parent = frame.f_back.f_code.co_name+"()"
            if len(kwargs)>1:
                msg = parent+" got invalid keyword arguments "
            else:
                msg = parent+" got an invalid keyword argument "
            raise TypeError(msg+", ".join(kwargs.keys()))
        finally:
            del frame
    return res
