#! /usr/bin/env python

import sys
import distutils.sysconfig, distutils.command.build_py
from distutils.core import setup
from os.path import join
from glob import glob

from csimgen import __version__

# borrowed from getmail:
#
# distutils doesn't seem to handle documentation files specially; they're
# just "data" files.  The problem is, there's no easy way to say "install
# the doc files under <prefix>/doc/<package>-<version>/ (obeying any
# --home=<althome> or --prefix=<altprefix>, which would be "normal".
# This hacks around this limitation.
prefix = distutils.sysconfig.get_config_var('prefix')
datadir = None
args = sys.argv[1:]
for (pos, arg) in enumerate(args):
    # hack hack hack
    if arg.startswith('--prefix='):
        # hack hack hack hack hack
        prefix = arg.split('=', 1)[1]
    elif arg == '--prefix':
        # hack hack hack hack hack hack hack
        prefix = args[pos + 1]
    elif arg.startswith('--install-data='):
        # hack hack hack hack hack
        datadir = arg.split('=', 1)[1]
    elif arg == '--install-data':
        # hack hack hack hack hack hack hack
        datadir = args[pos + 1]

BINDIR = distutils.sysconfig.get_config_var('BINDIR')

LIBDIR = join(distutils.sysconfig.get_config_var('LIBP'),
              'site-packages')

DATADIR = join(datadir or prefix,
               'share',
               'csimgen')

DOCDIR = join(datadir or prefix,
              'share',
              'doc',
              'csimgen')

if '--show-default-install-dirs' in args:
    print 'installation directories'
    print '  scripts:        %s' % BINDIR
    print '  Python modules: %s' % LIBDIR
    print '  data files:     %s' % DATADIR
    print '  documentation:  %s' % DOCDIR
    raise SystemExit()


class build_py(distutils.command.build_py.build_py):
    def _write_paths_py (self):
	print "hello"
	dd=dir(self)
	for d in dd:
	    print "  "+str(d)+": "+str(getattr(self,d))
	print "olleh"

    def copy_file (self, infile, outfile,
		   preserve_mode=1, preserve_times=1, link=None, level=1):
	if infile==join("csimgen","paths.py"):
	    print "autogenerating "+outfile
	    f=open(outfile,"w")
	    f.write('# paths.py - autogenerated file\n')
	    f.write('DATADIR="%s"\n'%DATADIR)
	    f.close()
	    return
	distutils.command.build_py.build_py.copy_file(self, infile, outfile,
						      preserve_mode,
						      preserve_times, link,
						      level)

    def run (self):
	#self._write_paths_py ()
	distutils.command.build_py.build_py.run (self)

setup(name='csimgen',
      version=__version__,
      description='C code generator for use in numerical simulations',
      author='Jochen Voss',
      author_email='voss@seehuhn.de',
      url='http://seehuhn.de/comp/csimgen',
      packages=['csimgen'],
      data_files=[(join(DATADIR,"LAPACK"),glob('sniplets/LAPACK/*.inc')),
                  (join(DATADIR,"licenses"),glob('sniplets/license/*')),
                  (DOCDIR,['README'])],
      cmdclass={'build_py': build_py}
      )
